////////////////////////////////////////////////////////////////////////////////
///
///		Title		: Binary Resource Loadeer Header
///
///		Copyright (c) 2007, NHN Co., Ltd. ALL RIGHTS RESERVED
///
///		Team		: Desktop Service Development
///
////////////////////////////////////////////////////////////////////////////////
#pragma once

#include "NPCommonUI.h"
#include <atlcoll.h>
#include "ImageProxy.h"
#include "AbstractResourceLoader.h"

//typedef const LPBYTE	LPCBYTE;
/**
* @ingroup 	Base Lib	
* @brief 	binary resource loader
* @date		02/13/2007
* @author	telltale
* @remark	\
	<?xml version="1.0" encoding="UTF-8" ?> \
	<resource> \
	<lang>ko_KR</lang> \
	<image id="0" const="IDB_BTN_MINUS" value="images/btn_minus.bmp"/>	 \
*/
class NPCOMMONUI_API CNBinaryResourceLoader : public AbstractResourceLoader
{
public:
	CNBinaryResourceLoader(void);
	virtual ~CNBinaryResourceLoader(void);

	///< initialize
	BOOL	Init(CNPUnzipFile* zipimage);
	///< uninitialize
	BOOL	Close();
	/**
	* @brief 	get image
	* @remark Let you call FreeImage when you destroy image
	*/
	IImage* GetImage(LPCTSTR id);

	///< free image
	void FreeImage(IImage* pImage);
	///< get binary
	BOOL GetBinary(CString id, CNByteArray& ByteArray);

	BOOL GetBinaryList(CAtlMap< CString, CString >& lstBinary);

private:
	///< parse xml
	BOOL	_ParseXML(const BYTE * pBuf);

	///< string map
	CAtlMap< CString, CString >	m_mapPath;
	///< image proxy map
	CAtlMap<CString, IImage*>	m_mapImage;
};